/** Based on InvenSense MPU-9250 register map document rev. 1.4, 9/9/2013 (RM-MPU-9250A-00)
   * 13/04/2014 by Conor Forde <me@conorforde.com>
   * Updates should be available at https://github.com/Snowda/MPU9250
   *
   * Changelog:
   *     ... - ongoing development release
   
  * NOTE: THIS IS ONLY A PARIAL RELEASE. 
  * THIS DEVICE CLASS IS CURRENTLY UNDERGOING ACTIVE DEVELOPMENT AND IS MISSING MOST FEATURES. 
   * PLEASE KEEP THIS IN MIND IF YOU DECIDE TO USE THIS PARTICULAR CODE FOR ANYTHING.
   */


   //MPU9250 Register map
   
   #define MPU9250_R 0xD1      //0b11010001
   #define MPU9250_W 0xD0     //0b11010000 
   
         
   #define MPU9250_SELF_TEST_Y_GYRO        0x01
   #define MPU9250_SELF_TEST_Z_GYRO        0x02
   
   #define MPU9250_SELF_TEST_X_ACCEL       0x0D
   #define MPU9250_SELF_TEST_Y_ACCEL       0x0E
   #define MPU9250_SELF_TEST_Z_ACCEL       0x0F
   
   #define MPU9250_XG_OFFSET_H             0x13
   #define MPU9250_XG_OFFSET_L             0x14
   #define MPU9250_YG_OFFSET_H             0x15
   #define MPU9250_YG_OFFSET_L             0x16
   #define MPU9250_ZG_OFFSET_H             0x17
   #define MPU9250_ZG_OFFSET_L             0x18
   #define MPU9250_SMPLRT_DIV              0x19
   #define MPU9250_CONFIG                  0x1A
   #define MPU9250_GYRO_CONFIG             0x1B
   #define MPU9250_ACCEL_CONFIG            0x1C
   #define MPU9250_ACCEL_CONFIG2           0x1D
   #define MPU9250_LP_ACCEL_ODR            0x1E
   #define MPU9250_WOM_THR                 0x1F
   
   #define MPU9250_FIFO_EN                 0x23
   #define MPU9250_I2C_MST_CTRL            0x24
   #define MPU9250_I2C_SLV0_ADDR           0x25
   #define MPU9250_I2C_SLV0_REG            0x26
   #define MPU9250_I2C_SLV0_CTRL           0x27
   #define MPU9250_I2C_SLV1_ADDR           0x28
   #define MPU9250_I2C_SLV1_REG            0x29
   #define MPU9250_I2C_SLV1_CTRL           0x2A
   #define MPU9250_I2C_SLV2_ADDR           0x2B
   #define MPU9250_I2C_SLV2_REG            0x2C
   #define MPU9250_I2C_SLV2_CTRL           0x2D
   #define MPU9250_I2C_SLV3_ADDR           0x2E
   #define MPU9250_I2C_SLV3_REG            0x2F
   #define MPU9250_I2C_SLV3_CTRL           0x30
   #define MPU9250_I2C_SLV4_ADDR           0x31
   #define MPU9250_I2C_SLV4_REG            0x32
   #define MPU9250_I2C_SLV4_DO             0x33
   #define MPU9250_I2C_SLV4_CTRL           0x34
   #define MPU9250_I2C_SLV4_DI             0x35
   #define MPU9250_I2C_MST_STATUS          0x36 //54
   #define MPU9250_INT_PIN_CFG             0x37 //55
   #define MPU9250_INT_ENABLE              0x38 //56
   
   #define MPU9250_INT_STATUS              0x3A //58
   #define MPU9250_ACCEL_XOUT_H            0x3B
   #define MPU9250_ACCEL_XOUT_L            0x3C
   #define MPU9250_ACCEL_YOUT_H            0x3D
   #define MPU9250_ACCEL_YOUT_L            0x3E
   #define MPU9250_ACCEL_ZOUT_H            0x3F
   #define MPU9250_ACCEL_ZOUT_L            0x40
   #define MPU9250_TEMP_OUT_H              0x41
   #define MPU9250_TEMP_OUT_L              0x42
   #define MPU9250_GYRO_XOUT_H             0x43
   #define MPU9250_GYRO_XOUT_L             0x44
   #define MPU9250_GYRO_YOUT_H             0x45
   #define MPU9250_GYRO_YOUT_L             0x46
   #define MPU9250_GYRO_ZOUT_H             0x47
   #define MPU9250_GYRO_ZOUT_L             0x48
   #define MPU9250_EXT_SENS_DATA_00        0x49
   #define MPU9250_EXT_SENS_DATA_01        0x4A
   #define MPU9250_EXT_SENS_DATA_02        0x4B
   #define MPU9250_EXT_SENS_DATA_03        0x4C
   #define MPU9250_EXT_SENS_DATA_04        0x4D
   #define MPU9250_EXT_SENS_DATA_05        0x4E
   #define MPU9250_EXT_SENS_DATA_06        0x4F
   #define MPU9250_EXT_SENS_DATA_07        0x50
   #define MPU9250_EXT_SENS_DATA_08        0x51
   #define MPU9250_EXT_SENS_DATA_09        0x52
   #define MPU9250_EXT_SENS_DATA_10        0x53
   #define MPU9250_EXT_SENS_DATA_11        0x54
   #define MPU9250_EXT_SENS_DATA_12        0x55
   #define MPU9250_EXT_SENS_DATA_13        0x56
   #define MPU9250_EXT_SENS_DATA_14        0x57
   #define MPU9250_EXT_SENS_DATA_15        0x58
   #define MPU9250_EXT_SENS_DATA_16        0x59
   #define MPU9250_EXT_SENS_DATA_17        0x5A
   #define MPU9250_EXT_SENS_DATA_18        0x5B
   #define MPU9250_EXT_SENS_DATA_19        0x5C
   #define MPU9250_EXT_SENS_DATA_20        0x5D
   #define MPU9250_EXT_SENS_DATA_21        0x5E
   #define MPU9250_EXT_SENS_DATA_22        0x5F
   #define MPU9250_EXT_SENS_DATA_23        0x60
   
   #define MPU9250_I2C_SLV0_DO             0x63
   #define MPU9250_I2C_SLV1_DO             0x64
   #define MPU9250_I2C_SLV2_DO             0x65
   #define MPU9250_I2C_SLV3_DO             0x66
   #define MPU9250_I2C_MST_DELAY_CTRL      0x67
   #define MPU9250_SIGNAL_PATH_RESET       0x68
   #define MPU9250_MOT_DETECT_CTRL         0x69
   #define MPU9250_USER_CTRL               0x6A
   #define MPU9250_PWR_MGMT_1              0x6B
   #define MPU9250_PWR_MGMT_2              0x6C
   
   #define MPU9250_FIFO_COUNTH             0x72
   #define MPU9250_FIFO_COUNTL             0x73
   #define MPU9250_FIFO_R_W                0x74
   #define MPU9250_WHO_AM_I                0x75
   #define MPU9250_XA_OFFSET_H             0x77
   #define MPU9250_XA_OFFSET_L             0x78
   
   #define MPU9250_YA_OFFSET_H             0x7A
   #define MPU9250_YA_OFFSET_L             0x7B
   
   #define MPU9250_ZA_OFFSET_H             0x7D
   #define MPU9250_ZA_OFFSET_L             0x7E
   
   //reset values
   #define WHOAMI_RESET_VAL                0x71
   #define POWER_MANAGMENT_1_RESET_VAL     0x01
   #define DEFAULT_RESET_VALUE             0x00
   
 //  #define WHOAMI_DEFAULT_VAL              0x68
//=============================================================
//Magnetometer register maps
 
   #define MPU9250_MAG_ADDRESS_W             0x18
   #define MPU9250_MAG_ADDRESS_R             0x19 

   #define MPU9250_MAG_WIA                 0x00
   #define MPU9250_MAG_INFO                0x01
   #define MPU9250_MAG_ST1                 0x02
   #define MPU9250_MAG_XOUT_L              0x03
   #define MPU9250_MAG_XOUT_H              0x04
   #define MPU9250_MAG_YOUT_L              0x05
   #define MPU9250_MAG_YOUT_H              0x06
   #define MPU9250_MAG_ZOUT_L              0x07
   #define MPU9250_MAG_ZOUT_H              0x08
   #define MPU9250_MAG_ST2                 0x09
   #define MPU9250_MAG_CNTL                0x0A
   #define MPU9250_MAG_RSV                 0x0B //reserved mystery meat
   #define MPU9250_MAG_ASTC                0x0C
   #define MPU9250_MAG_TS1                 0x0D
   #define MPU9250_MAG_TS2                 0x0E
   #define MPU9250_MAG_I2CDIS              0x0F
   #define MPU9250_MAG_ASAX                0x10
   #define MPU9250_MAG_ASAY                0x11
   #define MPU9250_MAG_ASAZ                0x12
//=============================================================
/*
#ifndef _MPU9250_H_
14	#define _MPU9250_H_
15	
16	#include <avr/pgmspace.h>
17	//MPU9250 Register map
18	
19	#define MPU9250_DEFAULT_ADDRESS         0xD1
20	#define MPU9250_ALT_DEFAULT_ADDRESS     0xD2   
21	
22	#define MPU9250_SELF_TEST_X_GYRO        0x00
23	#define MPU9250_SELF_TEST_Y_GYRO        0x01
24	#define MPU9250_SELF_TEST_Z_GYRO        0x02
25	
26	#define MPU9250_SELF_TEST_X_ACCEL       0x0D
27	#define MPU9250_SELF_TEST_Y_ACCEL       0x0E
28	#define MPU9250_SELF_TEST_Z_ACCEL       0x0F
29	
30	#define MPU9250_XG_OFFSET_H             0x13
31	#define MPU9250_XG_OFFSET_L             0x14
32	#define MPU9250_YG_OFFSET_H             0x15
33	#define MPU9250_YG_OFFSET_L             0x16
34	#define MPU9250_ZG_OFFSET_H             0x17
35	#define MPU9250_ZG_OFFSET_L             0x18
36	#define MPU9250_SMPLRT_DIV              0x19
37	#define MPU9250_CONFIG                  0x1A
38	#define MPU9250_GYRO_CONFIG             0x1B
39	#define MPU9250_ACCEL_CONFIG            0x1C
40	#define MPU9250_ACCEL_CONFIG2           0x1D
41	#define MPU9250_LP_ACCEL_ODR            0x1E
42	#define MPU9250_WOM_THR                 0x1F
43	
44	#define MPU9250_FIFO_EN                 0x23
45	#define MPU9250_I2C_MST_CTRL            0x24
46	#define MPU9250_I2C_SLV0_ADDR           0x25
47	#define MPU9250_I2C_SLV0_REG            0x26
48	#define MPU9250_I2C_SLV0_CTRL           0x27
49	#define MPU9250_I2C_SLV1_ADDR           0x28
50	#define MPU9250_I2C_SLV1_REG            0x29
51	#define MPU9250_I2C_SLV1_CTRL           0x2A
52	#define MPU9250_I2C_SLV2_ADDR           0x2B
53	#define MPU9250_I2C_SLV2_REG            0x2C
54	#define MPU9250_I2C_SLV2_CTRL           0x2D
55	#define MPU9250_I2C_SLV3_ADDR           0x2E
56	#define MPU9250_I2C_SLV3_REG            0x2F
57	#define MPU9250_I2C_SLV3_CTRL           0x30
58	#define MPU9250_I2C_SLV4_ADDR           0x31
59	#define MPU9250_I2C_SLV4_REG            0x32
60	#define MPU9250_I2C_SLV4_DO             0x33
61	#define MPU9250_I2C_SLV4_CTRL           0x34
62	#define MPU9250_I2C_SLV4_DI             0x35
63	#define MPU9250_I2C_MST_STATUS          0x36
64	#define MPU9250_INT_PIN_CFG             0x37
65	#define MPU9250_INT_ENABLE              0x38
66	
67	#define MPU9250_INT_STATUS              0x3A
68	#define MPU9250_ACCEL_XOUT_H            0x3B
69	#define MPU9250_ACCEL_XOUT_L            0x3C
70	#define MPU9250_ACCEL_YOUT_H            0x3D
71	#define MPU9250_ACCEL_YOUT_L            0x3E
72	#define MPU9250_ACCEL_ZOUT_H            0x3F
73	#define MPU9250_ACCEL_ZOUT_L            0x40
74	#define MPU9250_TEMP_OUT_H              0x41
75	#define MPU9250_TEMP_OUT_L              0x42
76	#define MPU9250_GYRO_XOUT_H             0x43
77	#define MPU9250_GYRO_XOUT_L             0x44
78	#define MPU9250_GYRO_YOUT_H             0x45
79	#define MPU9250_GYRO_YOUT_L             0x46
80	#define MPU9250_GYRO_ZOUT_H             0x47
81	#define MPU9250_GYRO_ZOUT_L             0x48
82	#define MPU9250_EXT_SENS_DATA_00        0x49
83	#define MPU9250_EXT_SENS_DATA_01        0x4A
84	#define MPU9250_EXT_SENS_DATA_02        0x4B
85	#define MPU9250_EXT_SENS_DATA_03        0x4C
86	#define MPU9250_EXT_SENS_DATA_04        0x4D
87	#define MPU9250_EXT_SENS_DATA_05        0x4E
88	#define MPU9250_EXT_SENS_DATA_06        0x4F
89	#define MPU9250_EXT_SENS_DATA_07        0x50
90	#define MPU9250_EXT_SENS_DATA_08        0x51
91	#define MPU9250_EXT_SENS_DATA_09        0x52
92	#define MPU9250_EXT_SENS_DATA_10        0x53
93	#define MPU9250_EXT_SENS_DATA_11        0x54
94	#define MPU9250_EXT_SENS_DATA_12        0x55
95	#define MPU9250_EXT_SENS_DATA_13        0x56
96	#define MPU9250_EXT_SENS_DATA_14        0x57
97	#define MPU9250_EXT_SENS_DATA_15        0x58
98	#define MPU9250_EXT_SENS_DATA_16        0x59
99	#define MPU9250_EXT_SENS_DATA_17        0x5A
100	#define MPU9250_EXT_SENS_DATA_18        0x5B
101	#define MPU9250_EXT_SENS_DATA_19        0x5C
102	#define MPU9250_EXT_SENS_DATA_20        0x5D
103	#define MPU9250_EXT_SENS_DATA_21        0x5E
104	#define MPU9250_EXT_SENS_DATA_22        0x5F
105	#define MPU9250_EXT_SENS_DATA_23        0x60
106	
107	#define MPU9250_I2C_SLV0_DO             0x63
108	#define MPU9250_I2C_SLV1_DO             0x64
109	#define MPU9250_I2C_SLV2_DO             0x65
110	#define MPU9250_I2C_SLV3_DO             0x66
111	#define MPU9250_I2C_MST_DELAY_CTRL      0x67
112	#define MPU9250_SIGNAL_PATH_RESET       0x68
113	#define MPU9250_MOT_DETECT_CTRL         0x69
114	#define MPU9250_USER_CTRL               0x6A
115	#define MPU9250_PWR_MGMT_1              0x6B
116	#define MPU9250_PWR_MGMT_2              0x6C
117	
118	#define MPU9250_FIFO_COUNTH             0x72
119	#define MPU9250_FIFO_COUNTL             0x73
120	#define MPU9250_FIFO_R_W                0x74
121	#define MPU9250_WHO_AM_I                0x75
122	#define MPU9250_XA_OFFSET_H             0x77
123	#define MPU9250_XA_OFFSET_L             0x78
124	
125	#define MPU9250_YA_OFFSET_H             0x7A
126	#define MPU9250_YA_OFFSET_L             0x7B
127	
128	#define MPU9250_ZA_OFFSET_H             0x7D
129	#define MPU9250_ZA_OFFSET_L             0x7E
130	
131	//reset values
132	#define WHOAMI_RESET_VAL                0x71
133	#define POWER_MANAGMENT_1_RESET_VAL     0x01
134	#define DEFAULT_RESET_VALUE             0x00
135	
136	#define WHOAMI_DEFAULT_VAL              0x68
137	
138	//CONFIG register masks
139	#define MPU9250_FIFO_MODE_MASK          0x40
140	#define MPU9250_EXT_SYNC_SET_MASK       0x38
141	#define MPU9250_DLPF_CFG_MASK           0x07
142	
143	//GYRO_CONFIG register masks
144	#define MPU9250_XGYRO_CTEN_MASK         0x80
145	#define MPU9250_YGYRO_CTEN_MASK         0x40
146	#define MPU9250_ZGYRO_CTEN_MASK         0x20
147	#define MPU9250_GYRO_FS_SEL_MASK        0x18
148	#define MPU9250_FCHOICE_B_MASK          0x03
149	
150	#define MPU9250_GYRO_FULL_SCALE_250DPS  0
151	#define MPU9250_GYRO_FULL_SCALE_500DPS  1
152	#define MPU9250_GYRO_FULL_SCALE_1000DPS 2
153	#define MPU9250_GYRO_FULL_SCALE_2000DPS 3
154	
155	//ACCEL_CONFIG register masks
156	#define MPU9250_AX_ST_EN_MASK           0x80
157	#define MPU9250_AY_ST_EN_MASK           0x40
158	#define MPU9250_AZ_ST_EN_MASK           0x20
159	#define MPU9250_ACCEL_FS_SEL_MASK       0x18
160	
161	#define MPU9250_FULL_SCALE_2G           0
162	#define MPU9250_FULL_SCALE_4G           1
163	#define MPU9250_FULL_SCALE_8G           2
164	#define MPU9250_FULL_SCALE_16G          3
165	
166	//ACCEL_CONFIG_2 register masks
167	#define MPU9250_ACCEL_FCHOICE_B_MASK    0xC0
168	#define MPU9250_A_DLPF_CFG_MASK         0x03
169	
170	//LP_ACCEL_ODR register masks
171	#define MPU9250_LPOSC_CLKSEL_MASK       0x0F
172	
173	//FIFO_EN register masks
174	#define MPU9250_TEMP_FIFO_EN_MASK       0x80
175	#define MPU9250_GYRO_XOUT_MASK          0x40
176	#define MPU9250_GYRO_YOUT_MASK          0x20
177	#define MPU9250_GYRO_ZOUT_MASK          0x10
178	#define MPU9250_ACCEL_MASK              0x08
179	#define MPU9250_SLV2_MASK               0x04
180	#define MPU9250_SLV1_MASK               0x02
181	#define MPU9250_SLV0_MASK               0x01
182	
183	//I2C_MST_CTRL register masks
184	#define MPU9250_MULT_MST_EN_MASK        0x80
185	#define MPU9250_WAIT_FOR_ES_MASK        0x40
186	#define MPU9250_SLV_3_FIFO_EN_MASK      0x20
187	#define MPU9250_I2C_MST_P_NSR_MASK      0x10
188	#define MPU9250_I2C_MST_CLK_MASK        0x0F
189	
190	//I2C_SLV0_ADDR register masks
191	#define MPU9250_I2C_SLV0_RNW_MASK       0x80
192	#define MPU9250_I2C_ID_0_MASK           0x7F
193	
194	//I2C_SLV0_CTRL register masks
195	#define MPU9250_I2C_SLV0_EN_MASK        0x80
196	#define MPU9250_I2C_SLV0_BYTE_SW_MASK   0x40
197	#define MPU9250_I2C_SLV0_REG_DIS_MASK   0x20
198	#define MPU9250_I2C_SLV0_GRP_MASK       0x10
199	#define MPU9250_I2C_SLV0_LENG_MASK      0x0F
200	
201	//I2C_SLV1_ADDR register masks
202	#define MPU9250_I2C_SLV1_RNW_MASK       0x80
203	#define MPU9250_I2C_ID_1_MASK           0x7F
204	
205	//I2C_SLV1_CTRL register masks
206	#define MPU9250_I2C_SLV1_EN_MASK        0x80
207	#define MPU9250_I2C_SLV1_BYTE_SW_MASK   0x40
208	#define MPU9250_I2C_SLV1_REG_DIS_MASK   0x20
209	#define MPU9250_I2C_SLV1_GRP_MASK       0x10
210	#define MPU9250_I2C_SLV1_LENG_MASK      0x0F
211	
212	//I2C_SLV2_ADDR register masks
213	#define MPU9250_I2C_SLV2_RNW_MASK       0x80
214	#define MPU9250_I2C_ID_2_MASK           0x7F
215	
216	//I2C_SLV2_CTRL register masks
217	#define MPU9250_I2C_SLV2_EN_MASK        0x80
218	#define MPU9250_I2C_SLV2_BYTE_SW_MASK   0x40
219	#define MPU9250_I2C_SLV2_REG_DIS_MASK   0x20
220	#define MPU9250_I2C_SLV2_GRP_MASK       0x10
221	#define MPU9250_I2C_SLV2_LENG_MASK      0x0F
222	
223	//I2C_SLV3_ADDR register masks
224	#define MPU9250_I2C_SLV3_RNW_MASK       0x80
225	#define MPU9250_I2C_ID_3_MASK           0x7F
226	
227	//I2C_SLV3_CTRL register masks
228	#define MPU9250_I2C_SLV3_EN_MASK        0x80
229	#define MPU9250_I2C_SLV3_BYTE_SW_MASK   0x40
230	#define MPU9250_I2C_SLV3_REG_DIS_MASK   0x20
231	#define MPU9250_I2C_SLV3_GRP_MASK       0x10
232	#define MPU9250_I2C_SLV3_LENG_MASK      0x0F
233	
234	//I2C_SLV4_ADDR register masks
235	#define MPU9250_I2C_SLV4_RNW_MASK       0x80
236	#define MPU9250_I2C_ID_4_MASK           0x7F
237	
238	//I2C_SLV4_CTRL register masks
239	#define MPU9250_I2C_SLV4_EN_MASK        0x80
240	#define MPU9250_SLV4_DONE_INT_EN_MASK   0x40
241	#define MPU9250_I2C_SLV4_REG_DIS_MASK   0x20
242	#define MPU9250_I2C_MST_DLY_MASK        0x1F
243	
244	//I2C_MST_STATUS register masks
245	#define MPU9250_PASS_THROUGH_MASK       0x80
246	#define MPU9250_I2C_SLV4_DONE_MASK      0x40
247	#define MPU9250_I2C_LOST_ARB_MASK       0x20
248	#define MPU9250_I2C_SLV4_NACK_MASK      0x10
249	#define MPU9250_I2C_SLV3_NACK_MASK      0x08
250	#define MPU9250_I2C_SLV2_NACK_MASK      0x04
251	#define MPU9250_I2C_SLV1_NACK_MASK      0x02
252	#define MPU9250_I2C_SLV0_NACK_MASK      0x01
253	
254	//INT_PIN_CFG register masks
255	#define MPU9250_ACTL_MASK               0x80
256	#define MPU9250_OPEN_MASK               0x40
257	#define MPU9250_LATCH_INT_EN_MASK       0x20
258	#define MPU9250_INT_ANYRD_2CLEAR_MASK   0x10
259	#define MPU9250_ACTL_FSYNC_MASK         0x08
260	#define MPU9250_FSYNC_INT_MODE_EN_MASK  0x04
261	#define MPU9250_BYPASS_EN_MASK          0x02
262	
263	//INT_ENABLE register masks
264	#define MPU9250_WOM_EN_MASK             0x40
265	#define MPU9250_FIFO_OFLOW_EN_MASK      0x10
266	#define MPU9250_FSYNC_INT_EN_MASK       0x08
267	#define MPU9250_RAW_RDY_EN_MASK         0x01
268	
269	//INT_STATUS register masks
270	#define MPU9250_WOM_INT_MASK            0x40
271	#define MPU9250_FIFO_OFLOW_INT_MASK     0x10
272	#define MPU9250_FSYNC_INT_MASK          0x08
273	#define MPU9250_RAW_DATA_RDY_INT_MASK   0x01
274	
275	//I2C_MST_DELAY_CTRL register masks
276	#define MPU9250_DELAY_ES_SHADOW_MASK    0x80
277	#define MPU9250_I2C_SLV4_DLY_EN_MASK    0x10
278	#define MPU9250_I2C_SLV3_DLY_EN_MASK    0x08
279	#define MPU9250_I2C_SLV2_DLY_EN_MASK    0x04
280	#define MPU9250_I2C_SLV1_DLY_EN_MASK    0x02
281	#define MPU9250_I2C_SLV0_DLY_EN_MASK    0x01
282	
283	//SIGNAL_PATH_RESET register masks
284	#define MPU9250_GYRO_RST_MASK           0x04
285	#define MPU9250_ACCEL_RST_MASK          0x02
286	#define MPU9250_TEMP_RST_MASK           0x01
287	
288	//MOT_DETECT_CTRL register masks
289	#define MPU9250_ACCEL_INTEL_EN_MASK     0x80
290	#define MPU9250_ACCEL_INTEL_MODE_MASK   0x40
291	
292	//USER_CTRL register masks
293	#define MPU9250_FIFO_EN_MASK            0x40
294	#define MPU9250_I2C_MST_EN_MASK         0x20
295	#define MPU9250_I2C_IF_DIS_MASK         0x10
296	#define MPU9250_FIFO_RST_MASK           0x04
297	#define MPU9250_I2C_MST_RST_MASK        0x02
298	#define MPU9250_SIG_COND_RST_MASK       0x01
299	
300	//PWR_MGMT_1 register masks
301	#define MPU9250_H_RESET_MASK            0x80
302	#define MPU9250_SLEEP_MASK              0x40
303	#define MPU9250_CYCLE_MASK              0x20
304	#define MPU9250_GYRO_STANDBY_CYCLE_MASK 0x10
305	#define MPU9250_PD_PTAT_MASK            0x08
306	#define MPU9250_CLKSEL_MASK             0x07
307	
308	//PWR_MGMT_2 register masks
309	#define MPU9250_DISABLE_XA_MASK         0x20
310	#define MPU9250_DISABLE_YA_MASK         0x10
311	#define MPU9250_DISABLE_ZA_MASK         0x08
312	#define MPU9250_DISABLE_XG_MASK         0x04
313	#define MPU9250_DISABLE_YG_MASK         0x02
314	#define MPU9250_DISABLE_ZG_MASK         0x01
315	
316	#define MPU9250_DISABLE_XYZA_MASK       0x38
317	#define MPU9250_DISABLE_XYZG_MASK       0x07
318	
319	//Magnetometer register maps
320	#define MPU9250_MAG_ADDRESS             0x0C
321	
322	#define MPU9250_MAG_WIA                 0x00
323	#define MPU9250_MAG_INFO                0x01
324	#define MPU9250_MAG_ST1                 0x02
325	#define MPU9250_MAG_XOUT_L              0x03
326	#define MPU9250_MAG_XOUT_H              0x04
327	#define MPU9250_MAG_YOUT_L              0x05
328	#define MPU9250_MAG_YOUT_H              0x06
329	#define MPU9250_MAG_ZOUT_L              0x07
330	#define MPU9250_MAG_ZOUT_H              0x08
331	#define MPU9250_MAG_ST2                 0x09
332	#define MPU9250_MAG_CNTL                0x0A
333	#define MPU9250_MAG_RSV                 0x0B //reserved mystery meat
334	#define MPU9250_MAG_ASTC                0x0C
335	#define MPU9250_MAG_TS1                 0x0D
336	#define MPU9250_MAG_TS2                 0x0E
337	#define MPU9250_MAG_I2CDIS              0x0F
338	#define MPU9250_MAG_ASAX                0x10
339	#define MPU9250_MAG_ASAY                0x11
340	#define MPU9250_MAG_ASAZ                0x12
341	
342	//Magnetometer register masks
343	#define MPU9250_WIA_MASK 0x48
344	 
345	

*/


